%% Import data
websave("Germany.csv",'https://www.football-data.co.uk/mmz4281/1920/D1.csv');
websave("England.csv",'https://www.football-data.co.uk/mmz4281/1920/E0.csv');
websave("Scotland.csv",'https://www.football-data.co.uk/mmz4281/1920/SC0.csv');
websave("Italy.csv",'https://www.football-data.co.uk/mmz4281/1920/I1.csv');
websave("Spain.csv",'https://www.football-data.co.uk/mmz4281/1920/SP1.csv');
websave("France.csv",'https://www.football-data.co.uk/mmz4281/1920/F1.csv');

England = readtable("England.csv");
France = readtable("France.csv");
Germany = readtable("Germany.csv");
Italy = readtable("Italy.csv");
Scotland = readtable("Scotland.csv");
Spain = readtable("Spain.csv");


%% Find accumulated points
League = struct('England',England,'France',France,'Germany',Germany,'Italy',Italy,'Scotland',Scotland,'Spain',Spain);
Name = ["England" "France" "Germany" "Italy" "Scotland" "Spain"];

for j = 1:6
    Teams = unique(getfield(League,Name(j)).HomeTeam);
    Points = zeros(size(Teams,1),1);
    
    for i = 1:size(getfield(League,Name(j)),1)
        for k = 1:size(Teams,1)
            if strcmp(getfield(League,Name(j)).HomeTeam(i),Teams{k}) == true...
                    && strcmp(getfield(League,Name(j)).FTR(i),'H') == true 
               Points(k) = Points(k) + 3;
            end
            if strcmp(getfield(League,Name(j)).AwayTeam(i),Teams{k}) == true...
                    && strcmp(getfield(League,Name(j)).FTR(i),'A') == true 
               Points(k) = Points(k) + 3;
            end
            if strcmp(getfield(League,Name(j)).HomeTeam(i),Teams{k}) == true...
                    && strcmp(getfield(League,Name(j)).FTR(i),'D') == true 
               Points(k) = Points(k) + 1;
            end
            if strcmp(getfield(League,Name(j)).AwayTeam(i),Teams{k}) == true...
                    && strcmp(getfield(League,Name(j)).FTR(i),'D') == true 
               Points(k) = Points(k) + 1;
            end
            
            Rank = table(Teams,Points); %Store them as table day by day
            Rank = sortrows(Rank,'Points',"descend"); %Sortable with any variable
        end
        Rank_season{i+1} = Rank; %Since it is table, storage needs to be cell
    end
    Rank_season{1} = table(Teams,zeros(size(Teams,1),1),'VariableNames',["Teams" "Points"]);
    League_season{j} = Rank_season;
    Teams = [];
    Rank_season = [];
end


%% Add ranking table
a = 1;
for j = 1:6
    League_tab = League_season{j};
    for i = 1:size(League_tab,2)
        Season = League_tab{i};
        for k = 1:size(Season,1)-1
            Game = Season.Points;
            if Game(k) == Game(k+1)
                Ranking(k+1) = a;
            else
                a = k+1;
                Ranking(k+1) = a;
            end
        end
        Ranking(1) = 1;
        League_season{j}{i} = [League_season{j}{i} table(Ranking','VariableNames',"Ranking")];  
        a = 1;
        Ranking = [];
    end
    Game = [];
    Season = [];
    League_tab = [];
end


%% Find giant killing games 
a = 1;
for j = 1:6
    League_tab = League_season{j};
    for i = 1:size(League_tab,2)-1       
        Home = getfield(League,Name(j)).HomeTeam(i);
        Away = getfield(League,Name(j)).AwayTeam(i);
        Team = League_tab{i}.Teams;
        Ranking = League_tab{i}.Ranking;
        Points = League_tab{i}.Points;
        Home_ranking = Ranking(find(string(Team) == Home));
        Away_ranking = Ranking(find(string(Team) == Away));
        Home_points = Points(find(string(Team) == Home));
        Away_points = Points(find(string(Team) == Away));        
        if Home_ranking - Away_ranking > length(Team)/3 && Away_points - Home_points > 12
            if getfield(League,Name(j)).FTR(i) == "H" 
                Index(a) = i;
                a = a + 1;
            end
        elseif Away_ranking - Home_ranking > length(Team)/3 && Home_points - Away_points > 12
            if getfield(League,Name(j)).FTR(i) == "A"
                Index(a) = i;
                a = a + 1;
            end
        end
    end
    GK{j} = Index;
    a = 1;
    Index = [];
    League_tab = [];
    Home = [];
    Away = [];
    Home_ranking = [];
    Away_ranking = [];
    ranking = [];
    Team = [];
    Home_points = [];
    Away_points = [];
end


%% Create table
Var_name = ["Home" "Away" "Full time result" "Points for home" "Points for away"...
    "Ranking for home" "Ranking for away"];
for i = 1:6
    League_tab = getfield(League,Name(i));
    Country = League_season{i};
    I = GK{i};
    for k = 1:length(I)
        Home{k} = League_tab.HomeTeam(I(k));
        Away{k} = League_tab.AwayTeam(I(k));
        FTR{k} = League_tab.FTR(I(k));
        Team = Country{I(k)}.Teams;
        Points = Country{I(k)}.Points;
        ranking = Country{I(k)}.Ranking;
        Points_home(k) = Points(find(string(Team) == string(Home{k})));
        Points_away(k) = Points(find(string(Team) == string(Away{k})));
        ranking_home(k) = ranking(find(string(Team) == string(Home{k})));
        ranking_away(k) = ranking(find(string(Team) == string(Away{k})));
        Points = [];
        ranking = [];
        Team = [];
    end    
    GK_tab{i} = table(string(Home)',string(Away)',string(FTR)',Points_home',Points_away',ranking_home',ranking_away',...
        'VariableNames',Var_name);
    Home = [];
    Away = [];
    FTR = [];
    Points_home = [];
    Points_away = [];
    ranking_home = [];
    ranking_away = [];
end


for i = 1:6
    writetable(GK_tab{i},strcat(Name{i},".xlsx"));
end